// MacrosServices.h: interface for the CMacrosServices class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MACROSSERVICES_H__F0A761F1_7BEE_11D2_B570_444553540000__INCLUDED_)
#define AFX_MACROSSERVICES_H__F0A761F1_7BEE_11D2_B570_444553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define CLSID_MacrosServices	"{2E98FF41-7C12-11d2-B570-444553540000}"
#define CLSID_MacroCommand		"{A300BBC1-807C-11d2-B570-444553540000}"

typedef void (*ENUMCOMMANDOPTIONS)(HWND hwnd, LPARAM lParam);

#define MCF_OPTIONLIST			0x0001
#define MCF_OPTIONTEXT			0x0002

typedef void* HMACRO;


class CMacroCommand
{
protected:
	PCSTR m_pcszClassId;
	PCSTR m_pcszName;

	UINT m_uFlags;
	CPlugIn* m_ppi;

public:
	CMacroCommand(CPlugIn* ppi, PCSTR pcszClassId, PCSTR pcszName, UINT uFlags)
	{
		m_ppi = ppi;
		m_pcszClassId = pcszClassId;
		m_pcszName = pcszName;
		m_uFlags = uFlags;
	}
	virtual ~CMacroCommand()
	{

	}

	virtual BOOL IsKindOf(PCSTR pcszClassId)
	{
		if ((strcmp(m_pcszClassId, pcszClassId) == 0) ||
			(strcmp(m_pcszClassId, CLSID_MacroCommand) == 0))
			return TRUE;

		return FALSE;
	}

	PCSTR GetClassId(void)
	{
		return m_pcszClassId;
	}

	PCSTR GetName(void)
	{
		return m_pcszName;
	}

	UINT GetFlags(void)
	{
		return m_uFlags;
	}

	virtual void Execute(PCSTR pcszOption, HANDLE hevent) = 0;
	virtual void EnumOptions(HWND hwnd)
	{

	}

	virtual void Reset(void)
	{

	}
};

class CMacrosServices : public CPlugInServices  
{
public:
	CMacrosServices(CPlugIn* ppi);
	virtual ~CMacrosServices();

	virtual void AddCommand(CMacroCommand* pmc);

	virtual HMACRO CreateMacro(PCSTR pcszName, PCSTR pcszKeyName, int iVirtualKey, BOOL bCtrl = FALSE, BOOL bAlt = FALSE, BOOL bShift = FALSE, BOOL bActive = TRUE);
	virtual void AddMacroCommand(HMACRO hmacro, PCSTR pcszCommandId, PCSTR pcszOption);
	virtual void CloseMacro(HMACRO hmacro);
	virtual void DeleteMacro(PCSTR pcszName);
};

#endif // !defined(AFX_MACROSSERVICES_H__F0A761F1_7BEE_11D2_B570_444553540000__INCLUDED_)
