// ObjectsServices.h: interface for the CObjectsServices class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OBJECTSSERVICES_H__00AECAA4_7952_11D2_B570_444553540000__INCLUDED_)
#define AFX_OBJECTSSERVICES_H__00AECAA4_7952_11D2_B570_444553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define ODS_GLOBAL		0
#define ODS_LOCAL		1

#define ODT_GENERAL		2
#define ODT_SPECIFIC	3


#define CLSID_ObjectsServices "{B2A04B41-795B-11d2-B570-444553540000}"

typedef void (*ENUMOBJNAMEPROC)(PCSTR pcszName, LPARAM lParam);

struct COUNTOBJECTSINFO
{
	WORD wType;
	BOOL bStackable;
	DWORD dwCount;
};

class CObjectsServices;

class CObjectsServices : public CPlugInServices  
{
protected:

public:
	CObjectsServices(CPlugIn* ppi);
	virtual ~CObjectsServices();

	virtual void EnumObjectNames(ENUMOBJNAMEPROC pfnEnumObjNameProc, LPARAM lParam);

	virtual DWORD ResolveObjectName(PCSTR pcszName, BOOL bMustOwn);
	virtual BOOL ResolveObjectName(PCSTR pcszName, BOOL bMustOwn, DWORD& dwId, WORD& wType, short& x, short& y, short& z);

	virtual BOOL CreateObject(PCSTR pcszName, UINT uScope = ODS_LOCAL);
	virtual BOOL CreateObject(PCSTR pcszName, UINT uScope, UINT uType, PCSTR pcszDescription, DWORD dwId, WORD wType, short x, short y, short z);
	virtual void CountObjects(UINT nObjects, COUNTOBJECTSINFO* pcoi);
};


#endif // !defined(AFX_OBJECTSSERVICES_H__00AECAA4_7952_11D2_B570_444553540000__INCLUDED_)
