
#ifndef PLUGIN_H
#define PLUGIN_H

// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the PLUGIN_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// PLUGIN_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef PLUGIN_EXPORTS
#define PLUGIN_API __declspec(dllexport)
#else
#define PLUGIN_API __declspec(dllimport)
#endif

#ifdef _MSC_VER
#pragma warning(disable : 4355)
#endif

#include <windows.h>
#include <commctrl.h>

class CCommand;
class CPlugInBridge;
class CPlugInServices ;
class CPlugIn;

#define PLUGIN_LOAD					0x1000
#define PLUGIN_UNLOAD				0x1001
#define PLUGIN_GETCPLUGINVERSION	0x1002
#define PLUGIN_GETFILEDEPENDENCIES	0x1003

#define PLUGINMAINPROCNAME	"PlugInMain"

typedef int (*PLUGINMAINPROC)(UINT uMsg, WPARAM wParam, LPARAM lParam);

#define CPLUGINVERSION		1000

#define CPI_ID				12555

#define PIE_CONNECT			0x0010
#define PIE_DISCONNECT		0x0011
#define PIE_SEND			0x0012
#define PIE_RECEIVE			0x0013
#define PIE_POSTSEND		0x0014
#define PIE_POSTRECEIVE		0x0015
#define PIE_INITINSTANCE	0x0016
#define PIE_EXITINSTANCE	0x0017
#define PIE_INITAPPLICATION	0x0018
#define PIE_READSETTINGS	0x0019
#define PIE_WRITESETTINGS	0x001a
#define PIE_CHARCRIMINAL	0x001b
#define PIE_CHARMOVE		0x001c
#define PIE_CHARPROFDEL		0x001d
#define PIE_CLIENTLOAD		0x001e
#define PIE_KEYDOWN			0x001f
#define PIE_CHAREQUIP		0x0020
#define PIE_SERVICESREADY	0x0021

#define WSF_FORCEGLOBAL		0x0001
#define WSF_SYSTEM			0x0002

typedef void* HPLUGINVIEW;
typedef void* HPLUGINBAR;
typedef void* HPLUGINNEW;
typedef void* HPLUGINHELP;
typedef void* HPLUGINMENU;
typedef void* HPLUGINOPTIONS;

#define PIM_GETVERBS		(WM_USER+580)
#define PIM_EXECUTEVERB		(WM_USER+581)

#define PIV_DELETE			0x0001
#define PIV_PROPERTIES		0x0002
#define PIV_OPEN			0x0004
#define PIV_CUT				0x0008
#define PIV_COPY			0x0010
#define PIV_PASTE			0x0020
#define PIV_FIND			0x0040
#define PIV_REFRESH			0x0080

#define COMMAND_PRIORITY_LOWEST			0
#define COMMAND_PRIORITY_BELOW_NORMAL	5
#define COMMAND_PRIORITY_NORMAL			10
#define COMMAND_PRIORITY_ABOVE_NORMAL	20
#define COMMAND_PRIORITY_HIGHEST		30


#define MAX_LAYERS			0x1e

#define LAYER_INVALID		0xff
#define LAYER_RIGHTHAND		0x01
#define LAYER_LEFTHAND		0x02
#define LAYER_FEET			0x03
#define LAYER_LEGS			0x04
#define LAYER_SHIRT			0x05
#define LAYER_HEAD			0x06
#define LAYER_HANDS			0x07
#define LAYER_RING			0x08
#define LAYER_NECK			0x0a
#define LAYER_HAIR			0x0b
#define LAYER_APRON			0x0c
#define LAYER_TUNIC			0x0d
#define LAYER_BRACELET		0x0e
#define LAYER_DOUBLET		0x11
#define LAYER_EARRINGS		0x12
#define LAYER_ARMS			0x13
#define LAYER_CLOAK			0x14
#define LAYER_BACKPACK		0x15
#define LAYER_ROBE			0x16
#define LAYER_SKIRT			0x17
#define LAYER_BANK			0x1d

#define MAX_SKILLS			49
#define MAX_SPELLS			64

#define SM_DEFAULT		0xffff


#define OBJECTID1(a)((BYTE)((a&0xff000000)>>24))
#define OBJECTID2(a)((BYTE)((a&0x00ff0000)>>16))
#define OBJECTID3(a)((BYTE)((a&0x0000ff00)>>8))
#define OBJECTID4(a)((BYTE)((a&0x000000ff)>>0))

__inline DWORD MAKEOBJECTID(BYTE* a) {
	return ((a[0]<<24)+(a[1]<<16)+(a[2]<<8)+(a[3]<<0));
}

#define OBJECT_HUMANMALE		0x0190
#define OBJECT_HUMANFEMALE		0x0191
#define OBJECT_CORPSE			0x2006


#define OBJECT_PACK_METALCHEST1		0x0e7c
#define OBJECT_PACK_METALCHEST2		0x09ab
#define OBJECT_PACK_GOLDBOX1		0x0e80
#define OBJECT_PACK_GOLDBOX2		0x09a8
#define OBJECT_PACK_WOODBOX1		0x0e7d
#define OBJECT_PACK_WOODBOX2		0x09aa
#define OBJECT_PACK_GOLDCHEST1		0x0e40
#define OBJECT_PACK_GOLDCHEST2		0x0e41
#define OBJECT_PACK_WOODCHEST1		0x0e42
#define OBJECT_PACK_WOODCHEST2		0x0e43
#define OBJECT_PACK_POUCH1			0x0e79
#define OBJECT_PACK_POUCH2			0x09b0

#define OBJECT_PACK_CORPSE			0x2006
#define OBJECT_PACK_BACKPACK1		0x0e75
#define OBJECT_PACK_BACKPACK2		0x09b2
#define OBJECT_PACK_BAG				0x0e76
#define OBJECT_PACK_BARREL			0x0e77
#define OBJECT_PACK_PICNICBASKET	0x0e7a
#define OBJECT_PACK_SMALLCRATE1		0x0e7e
#define OBJECT_PACK_SMALLCRATE2		0x09a9
#define OBJECT_PACK_BASKET			0x0990
#define OBJECT_PACK_REDDRAWERS1		0x0a38
#define OBJECT_PACK_DRAWERS2		0x0a2c
#define OBJECT_PACK_DRAWERS1		0x0a34
#define OBJECT_PACK_SHELVES1		0x0a9d
#define OBJECT_PACK_SHELVES2		0x0a9e
#define OBJECT_PACK_REDDRAWERS2		0x0a30
#define OBJECT_PACK_BIGCRATE1		0x0e3c
#define OBJECT_PACK_BIGCRATE2		0x0e3d
#define OBJECT_PACK_MEDCRATE1		0x0e3e
#define OBJECT_PACK_MEDCRATE2		0x0e3f
#define OBJECT_PACK_BOOKCASE1		0x0a97
#define OBJECT_PACK_BOOKCASE2		0x0a98
#define OBJECT_PACK_BOOKCASE3		0x0a99
#define OBJECT_PACK_BOOKCASE4		0x0a9a
#define OBJECT_PACK_BOOKCASE5		0x0a9b
#define OBJECT_PACK_BOOKCASE6		0x0a9c
#define OBJECT_PACK_REDARMOIRE3		0x0a4c
#define OBJECT_PACK_REDARMOIRE4		0x0a4d
#define OBJECT_PACK_ARMOIRE3		0x0a4e
#define OBJECT_PACK_ARMOIRE4		0x0a4f
#define OBJECT_PACK_REDARMOIRE1		0x0a50
#define OBJECT_PACK_REDARMOIRE2		0x0a51
#define OBJECT_PACK_ARMOIRE1		0x0a52
#define OBJECT_PACK_ARMOIRE2		0x0a53

#define GUMP_PACK_CORPSE		0x0009
#define GUMP_PACK_BACKPACK		0x003C
#define GUMP_PACK_BAG			0x003D
#define GUMP_PACK_BARREL		0x003E
#define GUMP_PACK_BASKET		0x003F
#define GUMP_PACK_SMALLBOX		0x0040
#define GUMP_PACK_BASIN			0x0041
#define GUMP_PACK_GOLDCHEST		0x0042
#define GUMP_PACK_BOX			0x0043
#define GUMP_PACK_CRATE			0x0044
#define GUMP_PACK_REDDRAWER		0x0048
#define GUMP_PACK_WOODCHEST		0x0049
#define GUMP_PACK_METALCHEST	0x004A
#define GUMP_PACK_GOLDBOX		0x004B
#define GUMP_PACK_SHIPHOLD		0x004c
#define GUMP_PACK_BOOKCASE		0x004D
#define GUMP_PACK_REDARMOIRE	0x004E
#define GUMP_PACK_ARMOIRE		0x004F
#define GUMP_PACK_DRAWER		0x0051

#define CLSID_PlugIn			"{F9E79301-7C8A-11d2-B570-C021E889714E}"
#define CLSID_PlugInServices	"{04428661-7C8C-11d2-B570-C021E889714E}"

typedef LRESULT (*CLIENTLOADPROC)(HWND hwnd, LPARAM lParam);

class PLUGIN_API PLUGINVERSION
{
public:
	DWORD m_dwMajorVersion;
	DWORD m_dwMinorVersion;
	DWORD m_dwBuildNumber;

	PLUGINVERSION();
	PLUGINVERSION(DWORD dwMajorVersion, DWORD dwMinorVersion, DWORD dwBuildNumber);
	BOOL operator<(const PLUGINVERSION& piver);
	BOOL operator>(const PLUGINVERSION& piver);
	BOOL operator>=(const PLUGINVERSION& piver);
	BOOL operator<=(const PLUGINVERSION& piver);
	BOOL operator==(const PLUGINVERSION& piver);
};

class PLUGIN_API CCommand  
{
protected:
	BYTE* m_pbCommand;
	UINT m_nCommandSize;

	BOOL m_bBlocks;
	BYTE* m_pbWaitForThis;
	UINT m_nWaitForThisSize;

	UINT m_uPriority;
	BOOL m_bRetry;

	CPlugIn*	m_ppi;

	HANDLE m_heventBlock;

public:

	CCommand(CPlugIn* ppi);
	virtual ~CCommand();

	void SetCommand(BYTE* pbCommand, UINT nCommandSize);
	void SetWaitForThis(BYTE* pbWaitForThis, UINT nWaitForThisSize);

	void SetPriority(UINT uPriority);
	UINT GetPriority(void);

	virtual BOOL OnReceive(BYTE* pbBuffer, UINT nNumberOfBytesReceived);
	virtual void Execute(void);

};



class PLUGIN_API CPlugInBridge
{
protected:

	void SetConnectedState(BOOL bConnected);
	BOOL GetConnectedState(void);

	void SetActiveFlag(CPlugIn* ppi, BOOL bActiveFlag);
	BOOL GetActiveFlag(CPlugIn* ppi);

	void SetInitFlag(CPlugIn* ppi, BOOL bInitFlag);
	BOOL GetInitFlag(CPlugIn* ppi);

	void SetCharacterName(char* pszCharacterName);
	PCSTR GetCharacterName(void);

	void SetCharacterId(DWORD dwId);
	DWORD GetCharacterId(void);

	void SetCharacterProfileName(PCSTR pcszCharacterProfileName);
	PCSTR GetCharacterProfileName(void);

	void SetCharacterEquipment(BYTE bLayer, DWORD dwId, WORD wType);
	DWORD GetCharacterEquipment(BYTE bLayer);

	void SetCharacterType(WORD wType);

	void SetCharacterCriminal(BOOL bCriminal);
	BOOL GetCharacterCriminal(void);

	void SetCharacterPos(short x, short y, short z, short dir);
	void GetCharacterPos(short& x, short& y, short& z, short& dir);

	void ResetAllData(void);
	void ResetCharacterEquipment(void);
	void ResetCharacterData(void);
	void ResetSkills(void);

	void SetTargetCursorState(DWORD dwId, BOOL bVisible);
	DWORD GetTargetCursorId(void);
	BOOL FilterTargetCursor(void);
	void SetTargetCursorIgnoreNext(BOOL bIgnoreNext);
	BOOL GetTargetCursorIgnoreNext(void);

	void SetMenuState(DWORD dwId, WORD wExtra, BOOL bVisible, WORD* pwChoices, UINT nChoices);
	DWORD GetMenuId(void);
	BOOL FilterMenu(void);
	void SetMenuIgnoreNext(BOOL bIgnoreNext);
	BOOL GetMenuIgnoreNext(void);

	BOOL GetUseIndividualSettings(void);
	void SetUseIndividualSettings(BOOL bUseIndividualSettings);

	virtual CPlugInServices* FindServices(PCSTR pcszClassId) = 0;

	virtual DWORD GetListViewExtendedStyle(void) = 0;
	virtual HWND GetFrameWindow(void) = 0;

	virtual HPLUGINVIEW AddView(HWND hwnd) = 0;
	virtual HPLUGINMENU AddMenu(PCSTR pcszName, HMENU hmenu, HWND hwnd) = 0;
	virtual HPLUGINOPTIONS AddOptions(PROPSHEETPAGE* ppsp) = 0;
	virtual HPLUGINNEW AddNew(PCSTR pcszName, HWND hwnd, WORD wId) = 0;
	virtual HPLUGINBAR AddBar(HWND hwnd) = 0;
	virtual HPLUGINHELP AddHelp(PCSTR pcszName, HWND hwnd, WORD wId) = 0;

	virtual void RemoveView(HPLUGINVIEW hpiview) = 0;
	virtual void RemoveMenu(HPLUGINMENU hpimenu) = 0;
	virtual void RemoveOptions(HPLUGINOPTIONS hpioptions) = 0;
	virtual void RemoveNew(HPLUGINNEW hpinew) = 0;
	virtual void RemoveBar(HPLUGINBAR hpibar) = 0;
	virtual void RemoveHelp(HPLUGINHELP hpihelp) = 0;


	virtual void ServerSend(BYTE* pbBuffer, UINT nNumberOfBytesToSend, CPlugIn* ppiGenerator) = 0;
	virtual void ClientSend(BYTE* pbBuffer, UINT nNumberOfBytesToSend, CPlugIn* ppiGenerator) = 0;
	virtual void QueueCommand(CCommand* pc) = 0;
	virtual void ClientSendKey(int iVirtualKey) = 0;
	virtual int ClientSendMessage(UINT uMsg, WPARAM wParam, LPARAM lParam) = 0;
	virtual LRESULT ClientLoadLibrary(PCSTR pcszLibraryName, LPARAM lParam) = 0;
	virtual HWND ClientGetWindow(void) = 0;
	virtual void OnEnableCharacterProfile(PCSTR pcszCharacterProfileName) = 0;

	virtual BOOL ReadSetting(PCSTR pcszName, float* pfValue, UINT uFlags, CPlugIn* ppi) = 0;
	virtual BOOL ReadSetting(PCSTR pcszName, DWORD* pdwValue, UINT uFlags, CPlugIn* ppi) = 0;
	virtual BOOL ReadSetting(PCSTR pcszName, PSTR pszText, UINT nTextSize, UINT uFlags, CPlugIn* ppi) = 0;
	virtual BOOL ReadSetting(PCSTR pcszName, BYTE* pbData, UINT nDataSize, UINT uFlags, CPlugIn* ppi) = 0;

	virtual BOOL WriteSetting(PCSTR pcszName, float fValue, UINT uFlags, CPlugIn* ppi) = 0;
	virtual BOOL WriteSetting(PCSTR psczName, DWORD dwValue, UINT uFlags, CPlugIn* ppi) = 0;
	virtual BOOL WriteSetting(PCSTR pcszName, PCSTR pcszText, UINT uFlags, CPlugIn* ppi) = 0;
	virtual BOOL WriteSetting(PCSTR pcszName, const BYTE* pcbData, UINT nDataSize, UINT uFlags, CPlugIn* ppi) = 0;



public:
	CPlugInBridge();
	virtual ~CPlugInBridge();

	virtual void Register(CPlugIn* ppi) = 0;
	virtual void Unregister(CPlugIn* ppi) = 0;


	friend class CPlugIn;
};


class PLUGIN_API CPlugInServices  
{
protected:
	CPlugIn* m_ppi;

	PCSTR m_pcszClassId;

public:
	CPlugInServices(PCSTR pcszClassId, CPlugIn* ppi);
	virtual ~CPlugInServices();

	PCSTR GetClassId(void);
	virtual BOOL IsKindOf(PCSTR pszClassId);

};

class PLUGIN_API CPlugIn {
private:
	static CPlugInBridge* m_ppib;

	static BOOL m_bConnected;

	static BOOL m_bUseIndividualSettings;

	struct CHARINFO 
	{
		char szProfileName[256];
		DWORD dwId;
		WORD wType;
		char szName[128];
		struct 
		{
			short x;
			short y;
			short z;
			short dir;
		} pos;


		struct EQUIPMENTINFO {
			DWORD dwId;
			WORD wType;
		} equipment[MAX_LAYERS];

		BOOL bCriminal;
		
	} static m_charinfo;

	struct SKILLINFO
	{
		PCSTR pcszName;
		BOOL bUseable;
		int iValue;
	} static m_skillinfo[MAX_SKILLS];

	struct SPELLINFO
	{
		PCSTR pcszName;
	} static m_spellinfo[MAX_SPELLS];

	struct LAYERINFO
	{
		PCSTR pcszName;
	} static m_layerinfo[MAX_LAYERS];

	struct TARGETCURSORINFO
	{
		HANDLE hevent;
		DWORD dwId;
		BOOL bVisible;
		BOOL bIgnoreNext;
		DWORD dwTicks;
		BOOL bFilter;
	} static m_tcinfo;

	struct MENUINFO
	{
		HANDLE hevent;
		DWORD dwId;
		WORD wExtra;
		BOOL bVisible;
		BOOL bFilter;
		BOOL bIgnoreNext;
		DWORD dwTicks;
		UINT nChoices;
		WORD* pwChoices;
	} static m_menuinfo;

	CPlugInServices* m_pServices;

	PCSTR m_pcszName;
	PCSTR m_pcszClassId;
	PLUGINVERSION m_ver;
	PCSTR m_pcszAuthor;

	BOOL m_bActiveFlag;
	BOOL m_bInitialized;

public:
	static BOOL m_bUnequipSpellbook;
	static UINT m_uCommandDelay;
	static WORD m_wSystemFontType;
	static WORD m_wSystemFontColor;

	CPlugIn(PCSTR pcszClassId, PCSTR pcszClassName, PLUGINVERSION ver, PCSTR pcszAuthor = "Unknown", CPlugInServices* pServices = NULL);
	virtual ~CPlugIn(void);

	PCSTR GetName(void);
	void GetVersion(PLUGINVERSION& ver);
	PCSTR GetAuthor(void);

	virtual BOOL IsKindOf(PCSTR pcszClassId);
	CPlugInServices* GetServices(void);
	PCSTR GetClassId(void);

	CPlugInServices* FindServices(PCSTR pcszClassId);


	static BOOL IsConnected(void);

	DWORD GetListViewExtendedStyle(void);
	HWND GetFrameWindow(void);

	HPLUGINVIEW AddView(HWND hwnd);
	HPLUGINMENU AddMenu(PCSTR pcszName, HMENU hmenu, HWND hwnd);
	HPLUGINOPTIONS AddOptions(PROPSHEETPAGE* ppsp);
	HPLUGINNEW AddNew(PCSTR pcszName, HWND hwnd, WORD wId);
	HPLUGINBAR AddBar(HWND hwnd);
	HPLUGINHELP AddHelp(PCSTR pcszName, HWND hwnd, WORD wId);

	void RemoveView(HPLUGINVIEW hpiview);
	void RemoveMenu(HPLUGINMENU hpimenu);
	void RemoveOptions(HPLUGINOPTIONS hpioptions);
	void RemoveNew(HPLUGINNEW hpinew);
	void RemoveBar(HPLUGINBAR hpibar);
	void RemoveHelp(HPLUGINHELP hpihelp);


	BOOL UseIndividualSettings(void);
	
	BOOL ReadSetting(PCSTR pcszName, float* pfValue, UINT uFlags = 0);
	BOOL ReadSetting(PCSTR pcszName, DWORD* pdwValue, UINT uFlags = 0);
	BOOL ReadSetting(PCSTR pcszName, PSTR pszText, UINT nTextSize, UINT uFlags = 0);
	BOOL ReadSetting(PCSTR pcszName, BYTE* pbData, UINT nDataSize, UINT uFlags = 0);

	BOOL WriteSetting(PCSTR pcszName, float fValue, UINT uFlags = 0);
	BOOL WriteSetting(PCSTR pcszName, DWORD dwValue, UINT uFlags = 0);
	BOOL WriteSetting(PCSTR pcszName, PCSTR pcszText, UINT uFlags = 0);
	BOOL WriteSetting(PCSTR pcszName, const BYTE* pcbData, UINT nDataSize, UINT uFlags = 0);

	void ClientSendKey(int iVirtualKey);
	int ClientSendMessage(UINT uMsg, WPARAM wParam, LPARAM lParam);
	LRESULT ClientLoadLibrary(PCSTR pcszLibraryName, LPARAM lParam);
	void ClientSend(BYTE* pbBuffer, UINT nNumberOfBytesToSend);
	HWND ClientGetWindow(void);
	void ServerSend(BYTE* pbBuffer, UINT nNumberOfBytesToSend);
	void QueueCommand(CCommand* pc);
	void EnableCharacterProfile(void);

	BOOL IsTargetCursorVisible(void);
	DWORD GetTargetCursorTicks(void);
	void SetTargetCursorIgnoreNext(BOOL bIgnoreNext);

	BOOL IsMenuVisible(void);
	DWORD GetMenuTicks(void);
	void SetMenuIgnoreNext(BOOL bIgnoreNext);

	PCSTR GetCharacterName(void);
	PCSTR GetCharacterProfileName(void);
	DWORD GetCharacterId(void);
	WORD GetCharacterType(void);
	BOOL IsCharacterCriminal(void);
	DWORD GetCharacterEquipment(BYTE bLayer);
	WORD GetCharacterEquipmentType(BYTE bLayer);
	void GetCharacterPos(short& x, short& y, short& z);

	PCSTR GetLayerName(int nLayer);
	int GetLayerNumber(PCSTR pcszName);

	PCSTR GetSpellName(int nSpell);
	int GetSpellNumber(PCSTR pcszName);

	PCSTR GetSkillName(int nSkill);
	int GetSkillNumber(PCSTR pcszName);
	BOOL IsSkillUseable(int nSkill);

	BOOL MenuSelect(UINT nChoice);
	BOOL WaitForMenu(DWORD dwWait = 30000);
	BOOL WaitForTargetCursor(DWORD dwWait = 30000);
	void UseSkill(int nSkill);
	void CastSpell(int nSpell);
	void UseObject(DWORD dwId);
	void OpenContainer(DWORD dwId);
	void ShowName(DWORD dwId);
	void ShowNameEx(DWORD dwId);
	void SystemMessage(PCSTR pcszMessage, WORD wColor = SM_DEFAULT, WORD wFont = SM_DEFAULT);
	void ShowTargetCursor(PCSTR pcszPrompt, DWORD dwId, BOOL bAllowLocations = FALSE);
	BOOL TargetObject(DWORD dwId, WORD wType, short x, short y, short z);
	void Say(PCSTR pcszText, BYTE bType = 0x00, WORD wColor = 0x03b2);
	void EquipLayer(BYTE bLayer, DWORD dwId);
	void UnequipLayer(BYTE bLayer, DWORD dwWhereId = 0);
	void UseObjectInLayer(BYTE bLayer);
	void RequestResync(void);
	void Say(DWORD dwId, PCSTR pcszText, WORD wColor, WORD wFont = 0x0003);
	void ShowStatus(DWORD dwId);

	void Register(void);
	void Unregister(void);

protected:
	virtual void InitApplication(PLUGINVERSION* ppiverPrevious);

	virtual BOOL InitInstance(void);
	virtual void ExitInstance(void);
	virtual void OnServicesReady(void);

	virtual void OnConnect(void);
	virtual void OnDisconnect(void);

	virtual void ReadSettings(void);
	virtual void WriteSettings(void);

	virtual void OnCharacterProfileDelete(PCSTR pcszProfileName);

	virtual void OnClientLoad(void);

	virtual BOOL OnKeyDown(int iVirtualKey, BOOL bCtrl, BOOL bAlt, BOOL bShift);

	virtual BOOL OnSend(BYTE* pbBuffer, UINT nNumberOfBytesSent, BOOL bFake, BOOL bSelfCreated);
	virtual BOOL OnReceive(BYTE* pbBuffer, UINT nNumberOfBytesReceived, BOOL bFake, BOOL bSelfCreated);

	virtual BOOL PostOnReceive(BYTE* pbBuffer, UINT nNumberOfBytesSent, BOOL bFake, BOOL bSelfCreated);
	virtual BOOL PostOnSend(BYTE* pbBuffer, UINT nNumberOfBytesSent, BOOL bFake, BOOL bSelfCreated);

	virtual void OnCharacterEquip(BYTE bLayer);
	virtual void OnCharacterMove(void);
	virtual void OnCharacterCriminal(void);

	virtual DWORD OnEvent(UINT uEvent, DWORD dwParam1, DWORD dwParam2, DWORD dwParam3, DWORD dwParam4);

public:

	DWORD _OnEvent(UINT uEvent, DWORD dwParam1, DWORD dwParam2, DWORD dwParam3, DWORD dwParam4);


	friend class CPlugInBridge;
};


#endif