// OptionsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Packet Log.h"
#include "PacketLogPlugIn.h"
#include "PacketLogOptionsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPacketLogOptionsDlg property page

IMPLEMENT_DYNAMIC(CPacketLogOptionsDlg, CPropertyPage)

CPacketLogOptionsDlg::CPacketLogOptionsDlg(CPacketLogPlugIn* plpi) : CPropertyPage(CPacketLogOptionsDlg::IDD)
{
	//{{AFX_DATA_INIT(CPacketLogOptionsDlg)
	m_bLogToFile = FALSE;
	m_szFileName = _T("PACKET.LOG");
	m_szFontName = _T("Courier New");
	m_nFontSize = 10;
	m_nUpdateInterval = 5000;
	//}}AFX_DATA_INIT

	m_plpi = plpi;
}

CPacketLogOptionsDlg::~CPacketLogOptionsDlg()
{
}

void CPacketLogOptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPacketLogOptionsDlg)
	DDX_Control(pDX, IDC_FILENAME, m_txtFileName);
	DDX_Check(pDX, IDC_LOGTOFILE, m_bLogToFile);
	DDX_Text(pDX, IDC_FILENAME, m_szFileName);
	DDV_MaxChars(pDX, m_szFileName, 256);
	DDX_Text(pDX, IDC_FONTNAME, m_szFontName);
	DDV_MaxChars(pDX, m_szFontName, 128);
	DDX_Text(pDX, IDC_FONTSIZE, m_nFontSize);
	DDV_MinMaxUInt(pDX, m_nFontSize, 4, 128);
	DDX_Text(pDX, IDC_UPDATEINTERVAL, m_nUpdateInterval);
	DDV_MinMaxUInt(pDX, m_nUpdateInterval, 10, 30000);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPacketLogOptionsDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CPacketLogOptionsDlg)
	ON_BN_CLICKED(IDC_LOGTOFILE, OnLogToFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPacketLogOptionsDlg message handlers

void CPacketLogOptionsDlg::OnOK() 
{
	// TODO: Add your specialized code here and/or call the base class

	UpdateData(TRUE);


	m_plpi->SetFileName(m_szFileName);
	m_plpi->SetLogToFile(m_bLogToFile);
	m_plpi->SetFontName(m_szFontName);
	m_plpi->SetFontSize(m_nFontSize);
	m_plpi->SetUpdateInterval(m_nUpdateInterval);
	
	CPropertyPage::OnOK();
}

void CPacketLogOptionsDlg::OnLogToFile() 
{
	// TODO: Add your control notification handler code here

	UpdateData(TRUE);

	m_txtFileName.EnableWindow(m_bLogToFile);
	
}

BOOL CPacketLogOptionsDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here

	m_plpi->GetFileName(m_szFileName);
	m_bLogToFile = m_plpi->GetLogToFile();
	m_plpi->GetFontName(m_szFontName);
	m_nFontSize = m_plpi->GetFontSize();
	m_nUpdateInterval = m_plpi->GetUpdateInterval();

	m_txtFileName.EnableWindow(m_bLogToFile);


	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
