// PacketLogPlugIn.h: interface for the CPacketLogPlugIn class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PACKETLOGPLUGIN_H__8D479012_771D_11D2_B570_444553540000__INCLUDED_)
#define AFX_PACKETLOGPLUGIN_H__8D479012_771D_11D2_B570_444553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "PacketLogView.h"
#include "PacketLogOptionsDlg.h"

#define CLSID_PacketLogPlugIn "{C176A840-7996-11d2-B570-444553540000}"

class CPacketLogPlugIn : public CPlugIn  
{
protected:

	CPacketLogView*	m_pview;
	CPacketLogOptionsDlg*	m_poptions;


	CCriticalSection	m_cs;

	CString		m_szFileName;
	BOOL		m_bLogToFile;
	BOOL		m_bEnableLogging;
	CString		m_szFontName;
	UINT		m_nFontSize;
	UINT		m_nUpdateInterval;

	HPLUGINBAR m_hpibar;
	HPLUGINOPTIONS m_hpioptions;
	HPLUGINVIEW m_hpiview;
	HPLUGINMENU m_hpimenu;
	HPLUGINHELP m_hpihelp;


	void AddText(char* pszHeader, BYTE* pbBuffer, UINT nNumberOfBytesToAdd);

	virtual BOOL OnSend(BYTE* pbBuffer, UINT nNumberOfBytesSent, BOOL bFake, BOOL bSelfCreated);
	virtual BOOL OnReceive(BYTE* pbBuffer, UINT nNumberOfBytesReceived, BOOL bFake, BOOL bSelfCreated);

	virtual BOOL InitInstance(void);
	virtual void ExitInstance(void);



public:
	CPacketLogPlugIn();
	virtual ~CPacketLogPlugIn();


	virtual void ReadSettings(void);
	virtual void WriteSettings(void);

	void GetFileName(CString& szFileName);
	BOOL GetLogToFile(void);
	BOOL GetEnableLogging(void);
	void GetFontName(CString& szFontName);
	UINT GetFontSize(void);
	UINT GetUpdateInterval(void);

	void SetFileName(CString& szFileName);
	void SetLogToFile(BOOL bLogToFile);
	void SetEnableLogging(BOOL bEnableLogging);
	void SetFontName(CString& szFontName);
	void SetFontSize(UINT nFontSize);
	void SetUpdateInterval(UINT nUpdateInterval);


};

#endif // !defined(AFX_PACKETLOGPLUGIN_H__8D479012_771D_11D2_B570_444553540000__INCLUDED_)
